Index: src/sas/sasgui/perspectives/calculator/model_editor.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/model_editor.py	(revision 95016615bc8960b6775d667f752de694493a3270)
+++ src/sas/sasgui/perspectives/calculator/model_editor.py	(revision ec72ceb76f0f8f97a43694dd5647f5a51b5c8b26)
@@ -70,5 +70,5 @@
 
     This Dialog pops up for the user when they press 'Sum|Multi(p1,p2)' under
-    'Edit Custom Model' under 'Fitting' menu.  This is currently called as
+    'Plugin Model Operations' under 'Fitting' menu.  This is currently called as
     a Modal Dialog.
 
Index: src/sas/sasgui/perspectives/calculator/pyconsole.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision 0912b405bd0067ba7456b60f02342b50c7f6671b)
+++ src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision ec72ceb76f0f8f97a43694dd5647f5a51b5c8b26)
@@ -103,5 +103,5 @@
     window_name = "Custom Model Editor"
     ## Name to appear on the window title bar
-    window_caption = "Custom Model Editor"
+    window_caption = "Plugin Model Editor"
     ## Flag to tell the AUI manager to put this panel in the center pane
     CENTER_PANE = False
Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision bc7b5da22222f028cc5564cd6e463dc47ef5f9e5)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision ec72ceb76f0f8f97a43694dd5647f5a51b5c8b26)
@@ -221,5 +221,5 @@
         self.id_edit = wx.NewId()
         editmodel_help = "Edit customized model sample file"
-        self.menu1.AppendMenu(self.id_edit, "Edit Custom Model",
+        self.menu1.AppendMenu(self.id_edit, "Plugin Model Operations",
                               self.edit_model_menu, editmodel_help)
         #create  menubar items
@@ -236,5 +236,5 @@
         frame = PyConsole(parent=self.parent, manager=self,
                           panel=self.fit_panel,
-                          title='Advanced Custom Model Editor',
+                          title='Advanced Plugin Model Editor',
                           filename=filename)
         self.put_icon(frame)
@@ -302,5 +302,5 @@
             event_id = event.GetId()
             dir_path = models.find_plugins_dir()
-            title = "New Custom Model Function"
+            title = "New Plugin Model Function"
             self.new_model_frame = EditorWindow(parent=self, base=self,
                                                 path=dir_path, title=title)
@@ -319,5 +319,5 @@
         Update custom model list in the fitpage combo box
         """
-        custom_model = 'Customized Models'
+        custom_model = 'Plugin Models'
         try:
             # Update edit menus
@@ -350,5 +350,5 @@
         wx_id = wx.NewId()
         #new_model_menu = wx.Menu()
-        self.edit_model_menu.Append(wx_id, 'New',
+        self.edit_model_menu.Append(wx_id, 'New Plugin Model',
                                    'Add a new model function')
         wx.EVT_MENU(owner, wx_id, self.make_new_model)
@@ -362,5 +362,5 @@
         self.edit_menu = wx.Menu()
         self.edit_model_menu.AppendMenu(e_id,
-                                    'Advanced', self.edit_menu)
+                                    'Advanced Plugin Editor', self.edit_menu)
         self.set_edit_menu_helper(owner, self.edit_custom_model)
 
@@ -368,9 +368,9 @@
         self.delete_menu = wx.Menu()
         self.edit_model_menu.AppendMenu(d_id,
-                                        'Delete', self.delete_menu)
+                                        'Delete Plugin Models', self.delete_menu)
         self.set_edit_menu_helper(owner, self.delete_custom_model)
 
         wx_id = wx.NewId()
-        self.edit_model_menu.Append(wx_id, 'Load Models',
+        self.edit_model_menu.Append(wx_id, 'Load Plugin Models',
           '(Re)Load all models present in user plugin_models folder')
         wx.EVT_MENU(owner, wx_id, self.load_plugin_models)