Index: src/sas/perspectives/fitting/basepage.py
===================================================================
--- src/sas/perspectives/fitting/basepage.py	(revision 74f6c7ef2a30f3e4674bc647b3dfa499c1b6bb97)
+++ src/sas/perspectives/fitting/basepage.py	(revision 0d9401e2f04996388ca18898d6743c03fe52a74a)
@@ -1861,129 +1861,4 @@
                               [max_state, max_value], unit])
            
-#    The following funcion seems to be superseded with fillsizer and 
-#    init combo box.  certainly it seems not to know about categories and uses 
-#    only shapes and shape independent -- tested after commenting out and does
-#    not seem to cause problem.  Leave commented out for now but delete in
-#    a code cleanup once clear it really is no longer used.
-#    PDB  8 April 2014
-
-#    def _set_model_sizer_selection(self, model):
-#        """
-#        Display the sizer according to the type of the current model
-#        """
-#        if model == None:
-#            return
-#        if hasattr(model, "s_model"):
-#            
-#            class_name = model.s_model.__class__
-#            name = model.s_model.name
-#            flag = (name != "NoStructure")
-#            if flag and \
-#                (class_name in self.model_list_box["Structure Factors"]):
-#                self.structurebox.Show()
-#                self.text2.Show()
-#                self.structurebox.Enable()
-#               self.text2.Enable()
- #               items = self.structurebox.GetItems()
- #               self.sizer1.Layout()
- #               
- #               for i in range(len(items)):
- #                   if items[i] == str(name):
- #                       self.structurebox.SetSelection(i)
- #                       break
- #                   
- #       if hasattr(model, "p_model"):
- #           class_name = model.p_model.__class__
- #           name = model.p_model.name
- #           self.formfactorbox.Clear()
- #           
- #           for k, list in self.model_list_box.iteritems():
- #               if k in["P(Q)*S(Q)", "Shapes"] and \
- #                   class_name in self.model_list_box["Shapes"]:
- #                   self.shape_rbutton.SetValue(True)
- #                   ## fill the form factor list with new model
- #                   self._populate_box(self.formfactorbox,
- #                                      self.model_list_box["Shapes"])
- #                   items = self.formfactorbox.GetItems()
- #                   ## set comboxbox to the selected item
- #                   for i in range(len(items)):
- #                       if items[i] == str(name):
- #                           self.formfactorbox.SetSelection(i)
- #                           break
- #                   return
- #               elif k == "Shape-Independent":
- #                   self.shape_indep_rbutton.SetValue(True)
- #               elif k == "Structure Factors":
- #                   self.struct_rbutton.SetValue(True)
- #               elif k == "Multi-Functions":
- #                   continue
- #               else:
- #                   self.plugin_rbutton.SetValue(True)
- #              
- #               if class_name in list:
- #                   ## fill the form factor list with new model
- #                   self._populate_box(self.formfactorbox, list)
- #                   items = self.formfactorbox.GetItems()
- #                   ## set comboxbox to the selected item
- #                   for i in range(len(items)):
- #                       if items[i] == str(name):
- #                           self.formfactorbox.SetSelection(i)
- #                           break
- #                   break
- #       else:
-            ## Select the model from the menu
-#            class_name = model.__class__
-#            name = model.name
-#            self.formfactorbox.Clear()
-#            items = self.formfactorbox.GetItems()
-#    
-#            for k, list in self.model_list_box.iteritems():
-#                if k in["P(Q)*S(Q)", "Shapes"] and \
-#                    class_name in self.model_list_box["Shapes"]:
-#                    if class_name in self.model_list_box["P(Q)*S(Q)"]:
-#                        self.structurebox.Show()
-#                        self.text2.Show()
-#                       self.structurebox.Enable()
-#                       self.structurebox.SetSelection(0)
-#                       self.text2.Enable()
-#                   else:
-#                        self.structurebox.Hide()
-#                        self.text2.Hide()
-#                        self.structurebox.Disable()
-#                        self.structurebox.SetSelection(0)
-#                        self.text2.Disable()
-#                        
-#                    self.shape_rbutton.SetValue(True)
-                    ## fill the form factor list with new model
-#                    self._populate_box(self.formfactorbox,
-#                                       self.model_list_box["Shapes"])
-#                    items = self.formfactorbox.GetItems()
-#                    ## set comboxbox to the selected item
-#                    for i in range(len(items)):
-#                        if items[i] == str(name):
-#                            self.formfactorbox.SetSelection(i)
-#                            break
-#                    return
-#                elif k == "Shape-Independent":
-#                    self.shape_indep_rbutton.SetValue(True)
-#                elif k == "Structure Factors":
-#                    self.struct_rbutton.SetValue(True)
-#                elif k == "Multi-Functions":
-#                    continue
-#                else:
-#                    self.plugin_rbutton.SetValue(True)
-#                if class_name in list:
-#                    self.structurebox.SetSelection(0)
-#                    self.structurebox.Disable()
-#                    self.text2.Disable()
-                    ## fill the form factor list with new model
-#                    self._populate_box(self.formfactorbox, list)
-#                    items = self.formfactorbox.GetItems()
-                    ## set comboxbox to the selected item
-#                    for i in range(len(items)):
-#                        if items[i] == str(name):
-#                            self.formfactorbox.SetSelection(i)
-#                            break
-#                    break
                 
     def _draw_model(self, update_chisqr=True, source='model'):