Index: src/sas/qtgui/DataExplorer.py
===================================================================
--- src/sas/qtgui/DataExplorer.py	(revision 454670d9c31222d3fd4e862e5308396fdd3ae7d4)
+++ src/sas/qtgui/DataExplorer.py	(revision 71361f01fa009014ff017ed99dc3e33eadca5cd0)
@@ -444,4 +444,15 @@
             plot2D.plot(plot_set)
             self.plotAdd(plot2D)
+            #============================================
+            ## Attach silx
+            #from silx.gui import qt
+            #from silx.gui.plot import StackView
+            #sv = StackView()
+            #sv.setColormap("jet", autoscale=True)
+            #sv.setStack(plot_set.data.reshape(1,100,100))
+            ##sv.setLabels(["x: -10 to 10 (200 samples)",
+            ##              "y: -10 to 5 (150 samples)"])
+            #sv.show()
+            #============================================
 
         for item, plot_set in plots:
Index: src/sas/qtgui/GuiManager.py
===================================================================
--- src/sas/qtgui/GuiManager.py	(revision 9c391946008e8a4e1faffbbcbca8f146fe72abcb)
+++ src/sas/qtgui/GuiManager.py	(revision 71361f01fa009014ff017ed99dc3e33eadca5cd0)
@@ -196,4 +196,5 @@
     def updatePerspective(self, data):
         """
+        Update perspective with data sent.
         """
         assert isinstance(data, list)
@@ -203,5 +204,4 @@
             msg = "No perspective is currently active."
             logging.info(msg)
-
 
     def communicator(self):
@@ -237,6 +237,6 @@
     def updateStatusBar(self, text):
         """
-        """
-        #self._workspace.statusbar.showMessage(text)
+        Set the status bar text
+        """
         self.statusLabel.setText(text)
 
@@ -287,13 +287,14 @@
         c = Connection(LocalConfig.__update_URL__, LocalConfig.UPDATE_TIMEOUT)
         response = c.connect()
-        if response is not None:
-            try:
-                content = response.read().strip()
-                logging.info("Connected to www.sasview.org. Latest version: %s"
-                             % (content))
-                version_info = json.loads(content)
-            except ValueError, ex:
-                logging.info("Failed to connect to www.sasview.org:", ex)
-        self.processVersion(version_info)
+        if response is None:
+            return
+        try:
+            content = response.read().strip()
+            logging.info("Connected to www.sasview.org. Latest version: %s"
+                            % (content))
+            version_info = json.loads(content)
+            self.processVersion(version_info)
+        except ValueError, ex:
+            logging.info("Failed to connect to www.sasview.org:", ex)
 
     def processVersion(self, version_info):
@@ -311,5 +312,4 @@
                 msg = "Could not connect to the application server."
                 msg += " Please try again later."
-                #self.SetStatusText(msg)
                 self.communicate.statusBarUpdateSignal.emit(msg)
 
Index: src/sas/qtgui/UI/DataExplorerUI.ui
===================================================================
--- src/sas/qtgui/UI/DataExplorerUI.ui	(revision 29eb9478bc719b304d48973c0134e96ca30a39bb)
+++ src/sas/qtgui/UI/DataExplorerUI.ui	(revision 71361f01fa009014ff017ed99dc3e33eadca5cd0)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>389</width>
-    <height>693</height>
+    <width>405</width>
+    <height>630</height>
    </rect>
   </property>
@@ -31,5 +31,5 @@
     <string>Data</string>
    </attribute>
-   <layout class="QGridLayout" name="gridLayout_6">
+   <layout class="QGridLayout" name="gridLayout_11">
     <item row="0" column="0">
      <widget class="QGroupBox" name="groupBox">
@@ -37,8 +37,8 @@
        <string>Data</string>
       </property>
-      <layout class="QGridLayout" name="gridLayout">
+      <layout class="QGridLayout" name="gridLayout_9">
        <item row="0" column="0">
-        <layout class="QHBoxLayout" name="horizontalLayout_2">
-         <item>
+        <layout class="QGridLayout" name="gridLayout">
+         <item row="0" column="0" rowspan="2">
           <widget class="QPushButton" name="cmdLoad">
            <property name="sizePolicy">
@@ -84,5 +84,12 @@
           </widget>
          </item>
-         <item>
+         <item row="0" column="1">
+          <widget class="QPushButton" name="cmdDeleteData">
+           <property name="text">
+            <string>Delete</string>
+           </property>
+          </widget>
+         </item>
+         <item row="1" column="1">
           <widget class="QComboBox" name="cbSelect">
            <property name="sizePolicy">
@@ -124,60 +131,22 @@
           </widget>
          </item>
-         <item>
-          <spacer name="horizontalSpacer_7">
-           <property name="orientation">
-            <enum>Qt::Horizontal</enum>
-           </property>
-           <property name="sizeHint" stdset="0">
-            <size>
-             <width>128</width>
-             <height>20</height>
-            </size>
-           </property>
-          </spacer>
-         </item>
-         <item>
-          <widget class="QPushButton" name="cmdDeleteData">
-           <property name="text">
-            <string>Delete</string>
-           </property>
-          </widget>
-         </item>
         </layout>
        </item>
-       <item row="1" column="0">
-        <widget class="QTreeView" name="treeView">
-         <property name="contextMenuPolicy">
-          <enum>Qt::NoContextMenu</enum>
-         </property>
-         <property name="acceptDrops">
-          <bool>true</bool>
-         </property>
-         <property name="editTriggers">
-          <set>QAbstractItemView::NoEditTriggers</set>
-         </property>
-         <property name="dragEnabled">
-          <bool>true</bool>
-         </property>
-         <property name="dragDropOverwriteMode">
-          <bool>true</bool>
-         </property>
-         <property name="dragDropMode">
-          <enum>QAbstractItemView::DropOnly</enum>
-         </property>
-         <property name="defaultDropAction">
-          <enum>Qt::CopyAction</enum>
-         </property>
-         <property name="selectionMode">
-          <enum>QAbstractItemView::ExtendedSelection</enum>
-         </property>
-         <attribute name="headerVisible">
-          <bool>false</bool>
-         </attribute>
-        </widget>
+       <item row="0" column="1">
+        <spacer name="horizontalSpacer_7">
+         <property name="orientation">
+          <enum>Qt::Horizontal</enum>
+         </property>
+         <property name="sizeHint" stdset="0">
+          <size>
+           <width>92</width>
+           <height>20</height>
+          </size>
+         </property>
+        </spacer>
        </item>
        <item row="2" column="0">
-        <layout class="QHBoxLayout" name="horizontalLayout">
-         <item>
+        <layout class="QGridLayout" name="gridLayout_2">
+         <item row="0" column="0" rowspan="2">
           <widget class="QPushButton" name="cmdSendTo">
            <property name="sizePolicy">
@@ -225,5 +194,5 @@
           </widget>
          </item>
-         <item>
+         <item row="0" column="1">
           <widget class="QComboBox" name="cbFitting">
            <property name="sizePolicy">
@@ -253,5 +222,5 @@
           </widget>
          </item>
-         <item>
+         <item row="1" column="1">
           <widget class="QCheckBox" name="chkBatch">
            <property name="text">
@@ -261,4 +230,35 @@
          </item>
         </layout>
+       </item>
+       <item row="1" column="0" colspan="2">
+        <widget class="QTreeView" name="treeView">
+         <property name="contextMenuPolicy">
+          <enum>Qt::NoContextMenu</enum>
+         </property>
+         <property name="acceptDrops">
+          <bool>true</bool>
+         </property>
+         <property name="editTriggers">
+          <set>QAbstractItemView::NoEditTriggers</set>
+         </property>
+         <property name="dragEnabled">
+          <bool>true</bool>
+         </property>
+         <property name="dragDropOverwriteMode">
+          <bool>true</bool>
+         </property>
+         <property name="dragDropMode">
+          <enum>QAbstractItemView::DropOnly</enum>
+         </property>
+         <property name="defaultDropAction">
+          <enum>Qt::CopyAction</enum>
+         </property>
+         <property name="selectionMode">
+          <enum>QAbstractItemView::ExtendedSelection</enum>
+         </property>
+         <attribute name="headerVisible">
+          <bool>false</bool>
+         </attribute>
+        </widget>
        </item>
       </layout>
@@ -266,61 +266,65 @@
     </item>
     <item row="1" column="0">
-     <layout class="QGridLayout" name="gridLayout_2">
-      <item row="0" column="0">
-       <widget class="QGroupBox" name="groupBox_3">
-        <property name="title">
-         <string>Plot</string>
-        </property>
-        <property name="flat">
-         <bool>false</bool>
-        </property>
-        <property name="checkable">
-         <bool>false</bool>
-        </property>
-        <layout class="QGridLayout" name="gridLayout_3">
-         <item row="0" column="0">
-          <widget class="QPushButton" name="cmdNew">
-           <property name="text">
-            <string>Create New</string>
-           </property>
-          </widget>
-         </item>
-         <item row="1" column="0">
-          <widget class="QPushButton" name="cmdAppend">
-           <property name="text">
-            <string>Append to</string>
-           </property>
-          </widget>
-         </item>
-         <item row="1" column="1">
-          <widget class="QComboBox" name="cbgraph">
-           <property name="sizePolicy">
-            <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
-             <horstretch>0</horstretch>
-             <verstretch>0</verstretch>
-            </sizepolicy>
-           </property>
-           <property name="sizeAdjustPolicy">
-            <enum>QComboBox::AdjustToContents</enum>
-           </property>
-          </widget>
-         </item>
-        </layout>
-       </widget>
+     <layout class="QGridLayout" name="gridLayout_10">
+      <item row="0" column="0" rowspan="2">
+       <layout class="QGridLayout" name="gridLayout_6">
+        <item row="0" column="0">
+         <widget class="QGroupBox" name="groupBox_3">
+          <property name="title">
+           <string>Plot</string>
+          </property>
+          <property name="flat">
+           <bool>false</bool>
+          </property>
+          <property name="checkable">
+           <bool>false</bool>
+          </property>
+          <layout class="QGridLayout" name="gridLayout_3">
+           <item row="0" column="0">
+            <widget class="QPushButton" name="cmdNew">
+             <property name="text">
+              <string>Create New</string>
+             </property>
+            </widget>
+           </item>
+           <item row="1" column="0">
+            <widget class="QPushButton" name="cmdAppend">
+             <property name="text">
+              <string>Append to</string>
+             </property>
+            </widget>
+           </item>
+           <item row="1" column="1">
+            <widget class="QComboBox" name="cbgraph">
+             <property name="sizePolicy">
+              <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
+               <horstretch>0</horstretch>
+               <verstretch>0</verstretch>
+              </sizepolicy>
+             </property>
+             <property name="sizeAdjustPolicy">
+              <enum>QComboBox::AdjustToContents</enum>
+             </property>
+            </widget>
+           </item>
+          </layout>
+         </widget>
+        </item>
+        <item row="0" column="1">
+         <spacer name="horizontalSpacer_3">
+          <property name="orientation">
+           <enum>Qt::Horizontal</enum>
+          </property>
+          <property name="sizeHint" stdset="0">
+           <size>
+            <width>103</width>
+            <height>48</height>
+           </size>
+          </property>
+         </spacer>
+        </item>
+       </layout>
       </item>
-      <item row="0" column="1">
-       <spacer name="horizontalSpacer_3">
-        <property name="orientation">
-         <enum>Qt::Horizontal</enum>
-        </property>
-        <property name="sizeHint" stdset="0">
-         <size>
-          <width>108</width>
-          <height>111</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-      <item row="0" column="2" alignment="Qt::AlignBottom">
+      <item row="1" column="1">
        <widget class="QPushButton" name="cmdHelp">
         <property name="text">