Index: theoryview/docs/sphinx/api/basepage.rst
===================================================================
--- theoryview/docs/sphinx/api/basepage.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/basepage.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+basepage
+******************************************************************************
+
+:mod:`sans.perspectives.theory.basepage`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.basepage
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/help_panel.rst
===================================================================
--- theoryview/docs/sphinx/api/help_panel.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/help_panel.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+help_panel
+******************************************************************************
+
+:mod:`sans.perspectives.theory.help_panel`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.help_panel
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/index.rst
===================================================================
--- theoryview/docs/sphinx/api/index.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/index.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,22 @@
+.. Autogenerated by genmods.py
+
+.. _api-index:
+
+##############################################################################
+   Reference
+##############################################################################
+
+.. only:: html
+
+   :Release: |version|
+   :Date: |today|
+
+.. toctree::
+
+   help_panel.rst
+   basepage.rst
+   model_panel.rst
+   model_thread.rst
+   models.rst
+   pagestate.rst
+   theory.rst
Index: theoryview/docs/sphinx/api/model_panel.rst
===================================================================
--- theoryview/docs/sphinx/api/model_panel.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/model_panel.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+model_panel
+******************************************************************************
+
+:mod:`sans.perspectives.theory.model_panel`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.model_panel
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/model_thread.rst
===================================================================
--- theoryview/docs/sphinx/api/model_thread.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/model_thread.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+model_thread
+******************************************************************************
+
+:mod:`sans.perspectives.theory.model_thread`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.model_thread
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/models.rst
===================================================================
--- theoryview/docs/sphinx/api/models.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/models.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+models
+******************************************************************************
+
+:mod:`sans.perspectives.theory.models`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.models
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/pagestate.rst
===================================================================
--- theoryview/docs/sphinx/api/pagestate.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/pagestate.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+pagestate
+******************************************************************************
+
+:mod:`sans.perspectives.theory.pagestate`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.pagestate
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: theoryview/docs/sphinx/api/theory.rst
===================================================================
--- theoryview/docs/sphinx/api/theory.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
+++ theoryview/docs/sphinx/api/theory.rst	(revision 74755ffa1ce766f8db2e7443abc981f716782e5c)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+theory
+******************************************************************************
+
+:mod:`sans.perspectives.theory.theory`
+==============================================================================
+
+.. automodule:: sans.perspectives.theory.theory
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+